#!/usr/bin/env python2.2

import commands
import os
import re

benchmark_dir = "~/CPHSTL/Report/In-place-multiway-heaps/Program/Benchmark/"
status_dir = "~/CPHSTL/Report/In-place-multiway-heaps/Program/Benchmark/Status/"
plot_dir = "~/CPHSTL/Report/In-place-multiway-heaps/Program/Benchmark/Plots/"
log_file = "log.txt"

model = ["sort"] 
input = ["int", "bigint", "ln", "pair"]
approach = ["Bbasic", "Btwo", "Bbin", "Bexp", "Bmove"]
computer = ["P4"]

for i in model:
  for j in input:
    for k in approach:
      for l in computer:
        pyfile = i + "-" + j + "-" + k + "-" + l + ".py"
        gpfile = "plot-" + i + "-" + j + "-" + k + "-" + l + ".gp"
        psfile = "plot-" + i + "-" + j + "-" + k + "-" + l + ".ps"
        outfile = "benzoutput-" + i + "-" + j + "-" + k + "-" + l + ".txt"
	try:
          all_outputs = ''
          command = "make clean"
          (status, output) = commands.getstatusoutput(command)
	  command = "python2.2 " + benchmark_dir + pyfile
          (status, output) = commands.getstatusoutput(command)
          if output != '':
            all_outputs += output

          #handle gp file
	  command = "ls plot.[0-9]*.gp"
          (status, output) = commands.getstatusoutput(command)  
          if output != '':
            #edit gp file
            f = open(output, 'r')
            s = f.read()
            f.close()
	    t =re.sub(r'set output ".+?"', 'set output "' + psfile + '"', s, 1)
            f = open(output, 'w')
            f.write(t)
            f.close()
            
            #move gp file
            command = "mv " + output + " " + plot_dir + gpfile
            (status, output) = commands.getstatusoutput(command)  
            if output != '':
	      all_outputs += output
          
          #handle ps file
	  command = "ls plot.[0-9]*.ps"
          (status, output) = commands.getstatusoutput(command)  
          if output != '':
            command = "mv " + output + " " + plot_dir + psfile
            (status, output) = commands.getstatusoutput(command)  
            if output != '':
              all_outputs += output

          f = open(os.path.expanduser(status_dir + outfile), 'w')
          f.write(all_outputs)
	  f.close()
	except:
          f = ''
          fullpath = os.path.expanduser(log_file)
          if os.path.exists(fullpath):
	    f = open(fullpath, 'a')
          else:
	    f = open(fullpath, 'w')
          print >>f, "Benchmark failed: " + pyfile
          f.close()

