#ifndef __do_nothing__
#define __do_nothing__

/*
A possible helper function when defining benchmarks.

Author: Jyrki Katajainen
Email: jyrki@diku.dk
Version: $Revision: 1.1 $
Date: $Date: 2003/10/29 23:14:46 $
*/

template <typename return_type>
return_type do_nothing() {
}

template <typename return_type, typename arg1>
return_type do_nothing(arg1) {
}

template <typename return_type, typename arg1, typename arg2>
return_type do_nothing(arg1, arg2) {
}

template <typename return_type, typename arg1, typename arg2, typename arg3>
return_type do_nothing(arg1, arg2, arg3) {
}

template <typename return_type, typename arg1, typename arg2, typename arg3,
  typename arg4>
return_type do_nothing(arg1, arg2, arg3, arg4) {
}

#endif // __do_nothing__
