#include <vector> // define std::vector
#include <iterator> // defines std::iterator_traits
#include <functional> // defines std::less

template <typename position, typename ordering>
void fun_if(position a, position b, const ordering& less) {

  typename std::iterator_traits<position>::difference_type top;
  
  for (position p = a; p < b - 1; p = p + 4) {
    if (less(*(p + 1), *p)) {
      if (less(*(p + 3),*(p + 2))) {
	if (less(*(p + 2), *p)) top = 0;
	else top = 2;
      }
      else {
	if (less(*(p + 3), *p)) top = 0;
	else top = 3;
      }
    }
    else {
      if (less(*(p + 3), *(p + 2))) {
	if (less(*(p + 2), *(p + 1))) top = 1;
	else top = 2;
      }
      else {
	if (less(*(p + 3), *(p + 1))) top = 1;
	else top = 3;
      }
    }    
  }
}





