#include <vector> // define std::vector
#include <iterator> // defines std::iterator_traits
#include <functional> // defines std::less

template <typename position, typename ordering>
void fun_if(position a, position b, const ordering& less) {
  typename std::iterator_traits<position>::difference_type top;

  for (position p = a; p < b - 1; p = p + 4) {
    top = 0;
    less(*(p + top), *(p + 1)) ? : top = 1;
    less(*(p + top), *(p + 2)) ? : top = 2;
    less(*(p + top), *(p + 3)) ? : top = 3;
  }
}




