#include <vector> // define std::vector
#include <iterator> // defines std::iterator_traits
#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  typename element, 
  typename container,
  typename position
>
class experiment {
public:
  experiment (unsigned int n) {
    a = container(n, element());
    random_sequence_with_seed(a.begin(), a.end(), 4321);
  }
  void primal() {
    fun_reg(a.begin(), a.end());
  }
private:
  unsigned int n;
  container a;
};







